/*
 * tmos - compiler.h 
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Fundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef __COMPILER_H
#define __COMPILER_H

#include <asm/compiler.h>

#ifdef SDCC
#define REENTRANT __reentrant
#else
#define REENTRANT
#endif

#ifndef __GNUC__
#define __attribute__(x) /* attribute */
#endif

#ifndef barrier
#if defined(__GCC__)
#define barrier() __asm__ __volatile__("": : :"memory")
#else
#define barrier()	/* not supported */
#endif
#endif

#if SDCC < 270
#define inline			/* not supported */
#endif

#if !defined(__GCC__) && !defined(HAVE_BUILTIN_CONSTANT_P)
#define __builtin_constant_p(x)	(0)
#endif

#define likely(x)	(x)
#define unlikely(x)	(x)

#if defined(HAVE_BUILTIN_PACK_16)
#define pack16(lo, hi)	__builtin_pack_16(lo, hi)
#else
#define pack16(lo, hi)	(((hi) << 8) | (lo))
#endif

#endif
