#ifndef __CRC16_H
#define __CRC16_H

#include <tmos/types.h>
#include <tmos/compiler.h>
#include <tmos/kernel.h>

#ifdef CONFIG_CRC16_DATA
u16 crc16_data(u16 crc, u8 const __data *buffer, unsigned char len)
	__preempt;
#endif
#ifdef CONFIG_CRC16_XDATA
u16 crc16_xdata(u16 crc, u8 const __xdata *buffer, unsigned char len)
	__preempt;
#endif
#ifdef CONFIG_CRC16_GENERIC
u16 crc16(u16 crc, u8 const *buffer, unsigned char len)
	__preempt;
#endif

#if CONFIG_KERNEL_XDATA
#define crc16_kernel(crc, buf, len)	crc16_xdata(crc, buf, len)
#elif CONFIG_KERNEL_DATA
#define crc16_kernel(crc, buf, len)	crc16_data(crc, buf, len)
#else
#define crc16_kernel(crc, buf, len)	crc16(crc, buf, len)
#endif

#if CONFIG_USER_XDATA
#define crc16_user(crc, buf, len)	crc16_xdata(crc, buf, len)
#elif CONFIG_USER_DATA
#define crc16_user(crc, buf, len)	crc16_data(crc, buf, len)
#else
#define crc16_user(crc, buf, len)	crc16(crc, buf, len)
#endif

#endif
